import java.io.*;
import java.util.*;
import javax.microedition.lcdui.*;

import com.xce.lcdui.*;
import com.xce.io.*;
import com.skt.m.*;

public class PinkCanvas extends Canvas implements XTimerListener
{

/*
** --------------------------------------------------------------------------------
**	Define 
** --------------------------------------------------------------------------------
*/

	// ܸ LCD 
	public final static int LCD_WIDTH			= 120;
	public final static int LCD_HEIGHT		= 144;
	public static int LCD_X;
	public static int LCD_Y;
	public final static int LCD_SOFTBAR		= 18;	// Ʈ 
	public final static int LCD_FHEIGHT		= Font.getDefaultFont().getHeight();


	// ̺Ʈ ν 
	public final static int EVT_PAINT			= 1;	// Paint Event
	public final static int EVT_KEY_PRESSED	= 2;	// Key Pressed Event
	public final static int EVT_KEY_RELEASED	= 3;	// Key Released Event


	public final static int STATUS_LIST		= 1;
	public final static int STATUS_POPOUP	= 2;
	public final static int STATUS_DIALOG	= 3;

	int curStatus = STATUS_LIST;
	int befStatus = STATUS_LIST;
/*
** --------------------------------------------------------------------------------
**	 
** --------------------------------------------------------------------------------
*/

	private int REAREA_X;				// ÷  X
	private int REAREA_Y;				// ÷  Y
	private int REAREA_WIDTH;		// ÷  WIDTH
	private int REAREA_HEIGHT;		// ÷  HEIGHT

	private final char[] subject = {'', 'ũ', '', '', 'Ʈ'};


	PinkMIDlet 	pinkMIDlet;
	PinkList 		pinkList;
	PinkSoftBar	pinkSoftBar;
	PinkPopup	pinkPopup;
	PinkDialog	pinkDialog;
	XTimer		xTimer;
		 

/*
** --------------------------------------------------------------------------------
**  Function:
** 	    XCanvas
**
**  Description:
** 	    .
**
**  Input:
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/

	PinkCanvas(PinkMIDlet pinkMIDlet)
	{
		LCD_X				= (this.getWidth() - LCD_WIDTH) / 2;
		LCD_Y				= (this.getHeight() + 16 - LCD_HEIGHT) / 2;
	
		this.pinkMIDlet = pinkMIDlet;

		pinkPopup 	= new PinkPopup(this);
		pinkSoftBar 	= new PinkSoftBar(this);
		pinkList 		= new PinkList(this);
		xTimer 		= new XTimer(300);
		pinkDialog	= new PinkDialog(this);
		
		xTimer.setTimerListener(this);
		xTimer.start();
		xTimer.cancel();
		

		char[][] exChars = {{'' ,'ũ', '', '', 'Ʈ', '', '', '0', '1'},
						{'' ,'ũ', '', '', 'Ʈ', '', '', '0', '2'},
						{'' ,'ũ', '', '', 'Ʈ', '', '', '0', '3'},
						{'' ,'ũ', '', '', 'Ʈ', '', '', '0', '4'},
						{'' ,'ũ', '', '', 'Ʈ', '', '', '0', '5'},
						{'' ,'ũ', '', '', 'Ʈ', '', '', '0', '6'},
						{'' ,'ũ', '', '', 'Ʈ', '', '', '0', '7'},
						{'' ,'ũ', '', '', 'Ʈ', '', '', '0', '8'},
						{'' ,'ũ', '', '', 'Ʈ', '', '', '0', '9'}};

		String[] exString = {"ũƮ01", 
							"ũƮ02",
							"ũƮ03",
							"ũƮ04",
							"ũƮ05",
							"ũƮ06",
							"ũƮ07",
							"ũƮ08",
							"ũƮ09"};

		pinkList.setChars(exChars, exChars.length, -1);
		pinkList.setBounds(LCD_X + 2, LCD_Y + 16, LCD_WIDTH - 4, LCD_HEIGHT - 16 - LCD_SOFTBAR);
		pinkList.setMargin(5, 2, 5, 3);
							
 	}



/*
** --------------------------------------------------------------------------------
**  Function:
** 	    performed
**
**  Description:
**
**
**  Input:
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/

	public void performed(XTimer aXTimer)
	{
		repaint(REAREA_X, REAREA_Y, REAREA_WIDTH, REAREA_HEIGHT);
	}

/*
** --------------------------------------------------------------------------------
**  Function:
** 	    paint
**
**  Description:
**
**
**  Input:
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/

	public void paint(Graphics g)
	{
		main_EventProc(EVT_PAINT, g, -1);
	}


/*
** --------------------------------------------------------------------------------
**  Function:
** 	    setRefreshArea
**
**  Description:
** 	    repaint  Ѵ.
**
**  Input:
**		x :
**		y :
**		width :
**		height :
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/
	public void setRefreshArea()
	{
		setRefreshArea(LCD_X, LCD_Y, LCD_WIDTH, LCD_HEIGHT);
	}

	public void setRefreshArea(int x, int y, int width, int height)
	{
		REAREA_X = x;
		REAREA_Y = y;
		REAREA_WIDTH = width;
		REAREA_HEIGHT = height;
	}


	public void repaintArea()
	{
		repaint(REAREA_X, REAREA_Y, REAREA_WIDTH, REAREA_HEIGHT);
		serviceRepaints();
	}



/*
** --------------------------------------------------------------------------------
**  Function:    
** 	    popup_init
**
**  Description: 
** 	    - ޴ ʱȭ Ų.
**
**  Input:	
** 
**  Return value:
**	    
** --------------------------------------------------------------------------------
*/

	public final static char[][] MENU00 = {{'', '', '0', '0'}, {'', '', '0', '1'}, {'', '', '0', '2'}, {'', '', '0', '4'}};


	public void popup_init(int status)
	{
		char[][] listPopup = null;	// ˾ 
		int numPopup = 0;		// ˾ 

		switch(status)
		{
			case STATUS_LIST:
				numPopup = 4;
//				listPopup = new char[][]{{'', '', '0', '0'}, {'', '', '0', '1'}, {'', '', '0', '2'}, {'', '', '0', '4'}};
				listPopup = MENU00;
				break;
		}

		pinkPopup.setChars(listPopup, numPopup);

/*		for(int i = 0; i < numPopup; i++)
		{
			if(listPopup[i] != null)
				listPopup[i] = null;			
		}

		if(listPopup != null)
			listPopup = null;*/
	}

	public final static char[] DIALOG00 = {'', '', '', '\n', 'D', 'i', 'a', 'l', 'o', 'g', ' ', 'â', '', '', '', '.'};
	public final static char[] SUBJECT00 = {'D', 'i', 'a', 'l', 'o', 'g'};

	public void popup_sel(int status)
	{
		switch(status)
		{
			case STATUS_LIST:
				switch(pinkPopup.getSelect())
				{
					case 0:
						pinkDialog.setChars(SUBJECT00, DIALOG00);

						curStatus = STATUS_DIALOG;
						break;

					case 1:
						curStatus = befStatus;
						break;

					case 2:
						break;

					case 3:
						break;
				}
				break;
		}
	}

/*
** --------------------------------------------------------------------------------
**  Function:
** 	    keyPressed
**
**  Description:
** 	    -  Ű  ó
**
**  Input:
**		// SK-VM Specific
**		KEY_CLR		= 8;
**
**	    	KEY_POUND 	= 35;
**	 	KEY_NUM0 	= 48;
**	    	KEY_NUM1 	= 49;
**	    	KEY_NUM2 	= 50;
**	    	KEY_NUM3 	= 51;
**	    	KEY_NUM4 	= 52;
**	    	KEY_NUM5 	= 53;
**	    	KEY_NUM6 	= 54;
**	    	KEY_NUM7 	= 55;
**	    	KEY_NUM8 	= 56;
**	    	KEY_NUM9 	= 57;
**	    	KEY_STAR 	= 42;
**
**		KEY_COML	= 129;
**		KEY_COMC	= 130;	// RESERVED
**		KEY_COMR	= 131;
**
**		KEY_UP		= 141;
**		KEY_LEFT		= 142;
**		KEY_RIGHT	= 145;
**		KEY_DOWN	= 146;
**		KEY_FIRE		= 148;
**
**		KEY_CALL	= 190;
**		KEY_END		= 191;
**
**		KEY_FLIP_OPEN	= 192;
**		KEY_FLIP_CLOSE	= 193;
**		KEY_VOL_UP		= 194;
**		KEY_VOL_DOWN	= 195;
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/


	public void keyPressed(int keyCode)
	{
		main_EventProc(EVT_KEY_PRESSED, null, keyCode);
	}

/*
** --------------------------------------------------------------------------------
**  Function:
** 	    keyReleased
**
**  Description:
**
**
**  Input:
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/

	public void keyReleased(int keyCode)
	{
		main_EventProc(EVT_KEY_RELEASED, null, keyCode);
	}


///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////



/*
** --------------------------------------------------------------------------------
**  Function:
** 	    main_EventProc
**
**  Description:
** 	    -  ν.
**
**  Input:
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/
	public void main_EventProc(int status, Graphics g, int keyCode)
	{
		switch(curStatus)
		{
/**********************************************************************************/
// Status List
/**********************************************************************************/
			case STATUS_LIST:
				switch(status)
				{
					case EVT_PAINT:
						g.setColor(0x00ff00);
						g.fillRect(LCD_X, LCD_Y, LCD_WIDTH, LCD_HEIGHT);
						
						g.setColor(0xff6daa);
						g.fillRect(LCD_X, LCD_Y, LCD_WIDTH, 15);
						g.setColor(0xff0000);
						g.drawRect(LCD_X, LCD_Y, LCD_WIDTH - 1, 14);

						g.setColor(0x000000);
						g.drawChars(subject, 0, subject.length, LCD_X + LCD_WIDTH / 2, LCD_Y + 1, g.HCENTER | g.TOP);

						pinkList.paint(g);

						pinkSoftBar.paint(g, PinkSoftBar.XSOFTBAR_MENU, PinkSoftBar.XSOFTBAR_4ARROW, PinkSoftBar.XSOFTBAR_ENTER);
						break;

					case EVT_KEY_PRESSED:
						switch(keyCode)
						{
							case Canvas.KEY_COML:
								xTimer.cancel();

								popup_init(curStatus);

								befStatus = curStatus;
								curStatus = STATUS_POPOUP;

								setRefreshArea();
								repaintArea();
								break;
						}
						
						pinkList.keyPressed(keyCode);
						break;

					case EVT_KEY_RELEASED:
						pinkList.keyReleased(keyCode);
						break;
				}
				break;

/**********************************************************************************/
// Status Popup
/**********************************************************************************/

			case STATUS_POPOUP:
				switch(status)
				{
					case PinkCanvas.EVT_PAINT:
						pinkPopup.paint(g);
						break;
						
					case PinkCanvas.EVT_KEY_PRESSED:
						pinkPopup.keyPressed(keyCode);

						switch(keyCode)
						{
//							case Canvas.KEY_CLR:
							case Canvas.KEY_COML:		//	= 129;
								xTimer.cancel();

								curStatus = befStatus;
								
								setRefreshArea();
								repaintArea();
								break;

//							case Canvas.KEY_FIRE:
							case Canvas.KEY_COMR:		//	= 148;	Nate Key
								xTimer.cancel();

								popup_sel(befStatus);
								
								setRefreshArea();
								repaintArea();
								break;
						}
						break;
						
					case PinkCanvas.EVT_KEY_RELEASED:
						pinkPopup.keyReleased(keyCode);
						break;
				}
				break;

/**********************************************************************************/
// Status Dialog
/**********************************************************************************/

			case STATUS_DIALOG:
				switch(status)
				{
					case PinkCanvas.EVT_PAINT:
						pinkDialog.paint(g);
						break;
						
					case PinkCanvas.EVT_KEY_PRESSED:
						xTimer.cancel();
						pinkDialog.xTimerDialog.cancel();

						curStatus = befStatus;

						setRefreshArea();
						repaintArea();
						break;
						
					case PinkCanvas.EVT_KEY_RELEASED:
						break;
				}
				break;
				
		}
	}
}
