import javax.microedition.lcdui.*;
import com.xce.lcdui.*;



public class PinkTicker
{
	private final static int DELAY_TURN			= 1;		// ticker_delay turn
	private final static int MOVESTRING_WIDTH	= 10;

	private char[] ticker_text;				// 

	private int TICKER_X;				// TICKER_X 
	private int TICKER_Y;				// TICKER_Y 
	private int TICKER_WIDTH;			// 
	private int TICKER_HEIGHT;		// 

	private int ticker_first;			// ù°  ̱
	private int ticker_second;			// ι°  ̱

	private int ticker_initDelay;
	private int ticker_delay;
	private int ticker_charsWidth;

	private int ticker_colorBack;
	private int ticker_colorFont;

	PinkCanvas pinkCanvas;

/************************************************************************/
//
	PinkTicker(PinkCanvas pinkCanvas)
	{
		this.pinkCanvas = pinkCanvas;
	}

/************************************************************************/
//
	public void setString(String _text)
	{
		setChars(_text.toCharArray());
	}

	public void setChars(char[] text, int offset, int length)
	{
		if(ticker_text != null)
			ticker_text = null;

		ticker_text = new char[length];

		System.arraycopy(text, offset, ticker_text, 0, length);

		ticker_first = 0;
		ticker_second = 0;
		ticker_delay = 0;

		ticker_charsWidth = Font.getDefaultFont().charsWidth(ticker_text, offset, length);
	}

	public void setChars(char[] text)
	{
		setChars(text, 0, text.length);
	}

/************************************************************************/
//
	public void setBounds(int _x, int _y, int _width, int _height)
	{
		this.TICKER_X = _x;
		this.TICKER_Y = _y;
		this.TICKER_WIDTH = _width;
		this.TICKER_HEIGHT = _height;
	}

	public void setColor(int _colorBack, int _colorFont)
	{
		ticker_colorBack = _colorBack;
		ticker_colorFont = _colorFont;
	}

	public void paint(Graphics g)
	{
		if(ticker_text.length == 0 || (TICKER_WIDTH == 0 && TICKER_HEIGHT == 0))
			return;

		g.setClip(TICKER_X, TICKER_Y, TICKER_WIDTH, TICKER_HEIGHT);

		// Color 
		g.setColor(ticker_colorBack);
		g.fillRect(TICKER_X, TICKER_Y, TICKER_WIDTH, TICKER_HEIGHT);

		if(ticker_charsWidth > TICKER_WIDTH)
		{
			if(ticker_delay++ > DELAY_TURN)
			{
				if(ticker_charsWidth+ ticker_initDelay >= ticker_first)
					ticker_first += MOVESTRING_WIDTH;

				if(ticker_charsWidth + ticker_initDelay >= ticker_second)
					ticker_second += MOVESTRING_WIDTH;

				if(ticker_charsWidth + ticker_initDelay < ticker_first)
				{
					ticker_first = ticker_second - ticker_charsWidth - 20;
					ticker_delay = 0;
				}

				if(ticker_charsWidth + ticker_initDelay < ticker_second)
					ticker_second = ticker_first - ticker_charsWidth - 20;
			} else
			{
				ticker_initDelay = ticker_first = -TICKER_X;
				ticker_second = ticker_first - ticker_charsWidth - 20;
			}

			//  ׸
			g.setColor(ticker_colorFont);
			g.drawChars(ticker_text, 0, ticker_text.length, -ticker_first, TICKER_Y, g.LEFT|g.TOP);
			g.drawChars(ticker_text, 0, ticker_text.length, -ticker_second, TICKER_Y, g.LEFT|g.TOP);
		}
		else
		{
			//  ׸
			g.setColor(ticker_colorFont);
			g.drawChars(ticker_text, 0, ticker_text.length, TICKER_X,
				TICKER_Y, g.LEFT|g.TOP);
		}

		g.setClip(0, 0, pinkCanvas.getWidth(), pinkCanvas.getHeight() + 16);
	}
}
