/**
 * <p>Title: MapEdit</p>
 * <p>Description: MapEditCanvas.java</p>
 * @author PinkRed
 * @version 0.5
 */
 
import java.io.*;
import java.util.*;
import javax.microedition.lcdui.*;

import com.xce.lcdui.*;
import com.xce.io.*;
import com.skt.m.*;

public class MapEditCanvas extends Canvas
{

/*
** --------------------------------------------------------------------------------
**	Define 
** --------------------------------------------------------------------------------
*/

	// ܸ LCD 
	public final static int LCD_WIDTH			= 640;
	public final static int LCD_HEIGHT		= 480;
	public final static int LCD_X				= 0;
	public final static int LCD_Y				= 0;


	// ̺Ʈ ν 
	public final static int EVT_PAINT			= 1;	// Paint Event
	public final static int EVT_KEY_PRESSED	= 2;	// Key Pressed Event
	public final static int EVT_KEY_RELEASED	= 3;	// Key Released Event


	// ̹  ũ
	public static int MAP_WIDTH;
	public static int MAP_HEIGHT;
	public static int MAP_X;
	public static int MAP_Y;
	public static int[]	MAP_INFO;

	// Ÿ ũ.
	public static int TILE_WIDTH;
	public static int TILE_HEIGHT;
	public static int TILE_X;
	public static int TILE_Y;

	// .
	public static String pathList	= "0";			// ù° Ʈ 

	public final static String pathInfo = "/project/MapEdit/jar/";		// INFO 
	public final static String pathTile = "/project/MapEdit/jar/tile/";	// TILE 


	public final static int STATUS_LIST	= 1;		// ޴ ֱ.
	public final static int STATUS_ITEM	= 2;		//   ϱ.

	public final static String MAP_FILE	= "mapInfo.dat";			//  
	public final static String TILE_FILE	= "tileInfo.txt";			// Ÿ 


 /*
** --------------------------------------------------------------------------------
**	Class 
** --------------------------------------------------------------------------------
*/

	MapEditMIDlet 	mapEditMIDlet;
 	XMapTileInfo[]	xMapTileInfo;
	XList		xList;


/*
** --------------------------------------------------------------------------------
**	 
** --------------------------------------------------------------------------------
*/

	private int REAREA_X;				// ÷  X
	private int REAREA_Y;				// ÷  Y
	private int REAREA_WIDTH;		// ÷  WIDTH
	private int REAREA_HEIGHT;		// ÷  HEIGHT


	int curStatus		= STATUS_LIST;
	int selTile;		//  õ Ÿ.
	boolean eraseMode;

/*
** --------------------------------------------------------------------------------
**  Function:
** 	    XCanvas
**
**  Description:
** 	    .
**
**  Input:
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/

	MapEditCanvas(MapEditMIDlet mapEditMIDlet)
	{
		this.mapEditMIDlet = mapEditMIDlet;

		xList = new XList(this);

		// MAP 
		byte[] buf = null;

		if((buf = read(pathInfo + "mapInfo.txt")) == null)
		{
			System.out.println("  б⸦ Ͽϴ.");
			return;
		}

		String mInfo = new String(buf);

		System.out.println("mInfo  : " + mInfo );

		int idx =0;
		MAP_WIDTH = Integer.parseInt(mInfo.substring(0, mInfo.indexOf(',')));
		idx = mInfo.indexOf(',');

		MAP_HEIGHT = Integer.parseInt(mInfo.substring(idx + 1, mInfo.indexOf(',', idx + 1)));
		idx = mInfo.indexOf(',', idx + 1);

		MAP_X = (LCD_WIDTH - MAP_WIDTH) / 2;
		MAP_Y = (LCD_HEIGHT - MAP_HEIGHT) / 2;

		System.out.println("MAP_WIDTH : " + MAP_WIDTH);
		System.out.println("MAP_HEIGHT : " + MAP_HEIGHT);


		MAP_INFO = new int[MAP_WIDTH * MAP_HEIGHT];
		
		TILE_WIDTH  = Integer.parseInt(mInfo.substring(idx + 1, mInfo.indexOf(',', idx + 1)));
		idx = mInfo.indexOf(',', idx + 1);

		TILE_HEIGHT  = Integer.parseInt(mInfo.substring(idx + 1, mInfo.length()));

		System.out.println("TILE_WIDTH : " + TILE_WIDTH);
		System.out.println("TILE_HEIGHT : " + TILE_HEIGHT);

		buf = null;
		mInfo = null;

		readMapTile();
		readInfo(pathList);

		TILE_X = MAP_WIDTH / TILE_WIDTH / 2 * TILE_WIDTH;
		TILE_Y = MAP_HEIGHT /TILE_HEIGHT / 2 * TILE_HEIGHT;		
 	}


	public void readMapTile()
	{
		// MAP 
		byte[] buf = null;

		if((buf = read(pathInfo + TILE_FILE)) == null)
		{
			System.out.println("Ÿ   б⸦ Ͽϴ!");
			return;
		}
	
		String tInfo = new String(buf);

		int idx = 0;
		int numList = Integer.parseInt(tInfo.substring(idx, tInfo.indexOf('\r', idx)));
		idx = tInfo.indexOf('\r', idx) + 2;

		xMapTileInfo = new XMapTileInfo[numList];

		try
		{
			for(int i = 0; i < numList; i++)
			{
				xMapTileInfo[i] = new XMapTileInfo();
				xMapTileInfo[i].TILE_NUM = Integer.parseInt(tInfo.substring(idx, tInfo.indexOf(',', idx)));
				idx = tInfo.indexOf(',', idx) + 1;

				System.out.println("xMapTileInfo[" + i + "].TILE_NUM : " + xMapTileInfo[i].TILE_NUM);

				xMapTileInfo[i].imgTile = Image.createImage(pathTile + tInfo.substring(idx, tInfo.indexOf('\r', idx)));
				idx = tInfo.indexOf('\r', idx) + 2;
			}
		}catch(Exception e)
		{
			System.out.println("Ÿ  µ Ͽϴ.!!!");
			return;
		}

		buf = null;
		tInfo = null;
	}


	public void readInfo(String name)
	{
		String mInfo = null;
		byte[] buf = null;

		if((buf = read(pathInfo + name + ".txt")) == null)
		{
			System.out.println(pathInfo + name + ".txt  ϴ.!!");
			return;
		}
		
		mInfo = new String(buf);

		// List ƴϸ..return
		if(mInfo.charAt(0) == 'l')
			readList(mInfo);
		else if(mInfo.charAt(0) == 't')
			readTile(mInfo);
		else
		{
			System.out.println("   : ù° ڰ ߸");
			return;
		}

		buf = null;
		mInfo = null;
	}


	public void readList(String infoList)
	{
		int idx = 2;
		int numList = Integer.parseInt(infoList.substring(2, infoList.indexOf('\r', idx)));
		idx = infoList.indexOf('\r', idx) + 2;

		String[] tmpList = new String[numList];

		for(int i = 0; i < numList; i++)
		{
			tmpList[i] = infoList.substring(idx, infoList.indexOf('\r', idx));
			idx = infoList.indexOf('\r', idx) + 2;
		}

		xList.setString(tmpList, numList, XList.TYPE_DEFAULT);
		xList.setBounds();
	}

	public void readTile(String infoTile)
	{
		int idx = 2;
		int numList = Integer.parseInt(infoTile.substring(2, infoTile.indexOf('\r', idx)));
		idx = infoTile.indexOf('\r', idx) + 2;

		System.out.println("infoTile : " + infoTile);
		System.out.println("numList : " + numList);

		XTileInfo[] tmpXTile = new XTileInfo[numList];

		for(int i = 0; i < numList; i++)
		{
			tmpXTile[i] = new XTileInfo();
			tmpXTile[i].infoName = infoTile.substring(idx, infoTile.indexOf(',', idx));
			idx = infoTile.indexOf(',', idx) + 1;

			System.out.println("tmpXTile[" + i + "].infoName : " + tmpXTile[i].infoName);

			tmpXTile[i].TILE_WIDTH = Integer.parseInt(infoTile.substring(idx, infoTile.indexOf(',', idx)));
			idx = infoTile.indexOf(',', idx) + 1;

			System.out.println("tmpXTile[" + i + "].TILE_WIDTH : " + tmpXTile[i].TILE_WIDTH);
			
			tmpXTile[i].TILE_HEIGHT = Integer.parseInt(infoTile.substring(idx, infoTile.indexOf(',', idx)));
			idx = infoTile.indexOf(',', idx) + 1;

			System.out.println("tmpXTile[" + i + "].TILE_HEIGHT : " + tmpXTile[i].TILE_HEIGHT);

			tmpXTile[i].infoTile = new int[tmpXTile[i].TILE_WIDTH / TILE_WIDTH * tmpXTile[i].TILE_HEIGHT / TILE_HEIGHT];

			for(int j = 0; j < tmpXTile[i].infoTile.length; j++)
			{
				tmpXTile[i].infoTile[j] = Integer.parseInt(infoTile.substring(idx, infoTile.indexOf(',', idx)));
				idx = infoTile.indexOf(',', idx) + 1;

				System.out.println("tmpXTile[" + i + "].infoTile[" + j + "] : " + tmpXTile[i].infoTile[j]);
			}
		
			idx = infoTile.indexOf('\r', idx) + 2;
		}

		xList.setString(tmpXTile, numList, XList.TYPE_ITEM);
		xList.setBounds();
	}


	public void drawTile(Graphics g, int tileNum, int x, int y)
	{
		int array = -1;

		if(tileNum == 0)
			return;
		
		for(int i = 0; i < xMapTileInfo.length; i++)
		{
			if(xMapTileInfo[i].TILE_NUM == tileNum)
			{
				array = i;
				break;
			}
 		}

		if(array >= 0)
			g.drawImage(xMapTileInfo[array].imgTile, x, y, g.LEFT | g.TOP);
	}



	public boolean loadFile()
	{
		int length = MAP_INFO.length;
		byte[] buf = null;

			
		if((buf = read(pathInfo + MAP_FILE)) == null)
		{
			System.out.println("ε Ͽϴ.");
			return false;
		}
		
		if(length != buf.length)
		{
			buf = null;
			
			System.out.println("ũⰡ ġ ʽϴ.!!");
			return false;
		}
		
		for(int i = 0; i < length; i++)
			MAP_INFO[i] = (int)buf[i];

		buf = null;

		return true;
	}



	public void saveFile()
	{
		byte[] buf = new byte[MAP_INFO.length];
		int length = MAP_INFO.length;

		for(int i = 0; i < length; i++)
			buf[i] = (byte)MAP_INFO[i];

		write(pathInfo + MAP_FILE, buf, 0, length);

		buf = null;
		return;
	}


	public byte[] read(String path)
	{
		XFile xFile = null;
		byte[] buf = null;
		
		try
		{
			//   ȮѴ.
			if(!XFile.exists(path))
			{
				System.out.println(path + " :   ʽϴ.");
				return null;
			}

			xFile = new XFile(path, XFile.READ);
			buf = new byte[xFile.available()];	
			
			xFile.read(buf, 0, buf.length);
			
		}catch(Exception e){}
		finally
		{
			try
			{
				if(xFile != null)
				{
					xFile.close();
					xFile = null;
				}
			}catch(Exception e1){}
		}

		return buf;
	}

	public void write(String path, byte[] buf, int offset, int length)
	{
		XFile xFile = null;
		
		try
		{
			//   .
			if(XFile.exists(path))
				XFile.unlink(path);

			xFile = new XFile(path, XFile.READ_WRITE);
			xFile.write(buf, offset, length);
			
		}catch(Exception e){}
		finally
		{
			try
			{
				if(xFile != null)
				{
					xFile.close();
					xFile = null;
				}
			}catch(Exception e1){}
		}

		return;
	}
	

/*
** --------------------------------------------------------------------------------
**  Function:
** 	    paint
**
**  Description:
**
**
**  Input:
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/

	public void paint(Graphics g)
	{
		main_EventProc(EVT_PAINT, g, -1);
	}


/*
** --------------------------------------------------------------------------------
**  Function:
** 	    setRefreshArea
**
**  Description:
** 	    repaint  Ѵ.
**
**  Input:
**		x :
**		y :
**		width :
**		height :
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/
	public void setRefreshArea()
	{
		setRefreshArea(LCD_X, LCD_Y, LCD_WIDTH, LCD_HEIGHT);
	}

	public void setRefreshArea(int x, int y, int width, int height)
	{
		REAREA_X = x;
		REAREA_Y = y;
		REAREA_WIDTH = width;
		REAREA_HEIGHT = height;
	}


	public void repaintArea()
	{
		repaint(REAREA_X, REAREA_Y, REAREA_WIDTH, REAREA_HEIGHT);
		serviceRepaints();
	}




/*
** --------------------------------------------------------------------------------
**  Function:
** 	    keyPressed
**
**  Description:
** 	    -  Ű  ó
**
**  Input:
**		// SK-VM Specific
**		KEY_CLR		= 8;
**
**	    	KEY_POUND 	= 35;
**	 	KEY_NUM0 	= 48;
**	    	KEY_NUM1 	= 49;
**	    	KEY_NUM2 	= 50;
**	    	KEY_NUM3 	= 51;
**	    	KEY_NUM4 	= 52;
**	    	KEY_NUM5 	= 53;
**	    	KEY_NUM6 	= 54;
**	    	KEY_NUM7 	= 55;
**	    	KEY_NUM8 	= 56;
**	    	KEY_NUM9 	= 57;
**	    	KEY_STAR 	= 42;
**
**		KEY_COML	= 129;
**		KEY_COMC	= 130;	// RESERVED
**		KEY_COMR	= 131;
**
**		KEY_UP		= 141;
**		KEY_LEFT		= 142;
**		KEY_RIGHT	= 145;
**		KEY_DOWN	= 146;
**		KEY_FIRE		= 148;
**
**		KEY_CALL	= 190;
**		KEY_END		= 191;
**
**		KEY_FLIP_OPEN	= 192;
**		KEY_FLIP_CLOSE	= 193;
**		KEY_VOL_UP		= 194;
**		KEY_VOL_DOWN	= 195;
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/


	public void keyPressed(int keyCode)
	{
		main_EventProc(EVT_KEY_PRESSED, null, keyCode);
	}

/*
** --------------------------------------------------------------------------------
**  Function:
** 	    keyReleased
**
**  Description:
**
**
**  Input:
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/

	public void keyReleased(int keyCode)
	{
		main_EventProc(EVT_KEY_RELEASED, null, keyCode);
	}


///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////



/*
** --------------------------------------------------------------------------------
**  Function:
** 	    main_EventProc
**
**  Description:
** 	    -  ν.
**
**  Input:
**
**  Return value:
**
** --------------------------------------------------------------------------------
*/
	public void main_EventProc(int status, Graphics g, int keyCode)
	{
		switch(curStatus)
		{

// --------------------------------------------------------------------------------
//		
// --------------------------------------------------------------------------------
		
			case STATUS_LIST:
				switch(status)
				{
					case EVT_PAINT:
						g.setColor(0xffffff);
						g.fillRect(LCD_X, LCD_Y, LCD_WIDTH, LCD_HEIGHT);
						
						g.setColor(0x000000);
						g.drawRect(MAP_X - 1, MAP_Y - 1, MAP_WIDTH + 1, MAP_HEIGHT + 1);

						for(int i = 0, j = 0; i * TILE_HEIGHT < MAP_HEIGHT; i++)
							for(j = 0; j * TILE_WIDTH < MAP_WIDTH; j++)
								drawTile(g, MAP_INFO[i * MAP_WIDTH / TILE_WIDTH + j], MAP_X + j * TILE_WIDTH, MAP_Y + i * TILE_HEIGHT);

						xList.paint(g);
						break;

					case EVT_KEY_PRESSED:				
						xList.keyPressed(keyCode);

						switch(keyCode)
						{
							case Canvas.KEY_FIRE:
								if(xList.getAnchor() == XList.TYPE_ITEM)
								{
									curStatus = STATUS_ITEM;

									selTile = xList.getTileNum();

									setRefreshArea();
									repaintArea();
								}
								break;
								
							case Canvas.KEY_COMR:
								if(xList.getAnchor() == XList.TYPE_DEFAULT)
								{
									if(pathList.length() == 1)
									{
										switch(xList.getSelect())
										{
											case 0:
												if(loadFile())
													System.out.println("ε Ϸ");
												else
													System.out.println("ε ");
												break;
												
											case 1:
												saveFile();

												System.out.println(" Ϸ");
												break;
												
											case 2://  .
												eraseMode = true;

												curStatus = STATUS_ITEM;

												TILE_X = MAP_WIDTH / TILE_WIDTH / 2 * TILE_WIDTH;
												TILE_Y = MAP_HEIGHT /TILE_HEIGHT / 2 * TILE_HEIGHT;
												break;
												
											default:
												eraseMode = false;
												pathList = pathList + "_" + xList.getSelect();
												readInfo(pathList);
												break;
										}
									}else
									{
										eraseMode = false;
									
										pathList = pathList + "_" + xList.getSelect();
										readInfo(pathList);
									}
									
									setRefreshArea();
									repaintArea();
								}
								break;

							case Canvas.KEY_CLR:
								if(pathList.lastIndexOf('_') > 0)
								{
									pathList = pathList.substring(0, pathList.lastIndexOf('_'));
									readInfo(pathList);							
									
									setRefreshArea();
									repaintArea();
								}
								break;
						}
						break;

					case EVT_KEY_RELEASED:
						xList.keyReleased(keyCode);
						break;
				}
				break;

// --------------------------------------------------------------------------------
//		
// --------------------------------------------------------------------------------

			case STATUS_ITEM:
				switch(status)
				{
					case EVT_PAINT:
						g.setColor(0xffffff);
						g.fillRect(LCD_X, LCD_Y, LCD_WIDTH, LCD_HEIGHT);
						
						g.setColor(0x000000);
						g.drawRect(MAP_X - 1, MAP_Y - 1, MAP_WIDTH + 1, MAP_HEIGHT + 1);

						g.setClip(MAP_X, MAP_Y, MAP_WIDTH, MAP_HEIGHT);
						
						for(int i = 0, j = 0; i * TILE_HEIGHT < MAP_HEIGHT; i++)
							for(j = 0; j * TILE_WIDTH < MAP_WIDTH; j++)
								drawTile(g, MAP_INFO[i * MAP_WIDTH / TILE_WIDTH + j], MAP_X + j * TILE_WIDTH, MAP_Y + i * TILE_HEIGHT);

						g.setColor(0x000000);
						g.drawRect(MAP_X + TILE_X - 1, MAP_Y + TILE_Y - 1,
							xList.getTile().TILE_WIDTH + 1, xList.getTile().TILE_HEIGHT + 1);

						if(!eraseMode)
							drawTile(g, selTile, MAP_X + TILE_X, MAP_Y + TILE_Y);

						g.setClip(LCD_X, LCD_Y, LCD_WIDTH, LCD_HEIGHT);
						break;
						
					case EVT_KEY_PRESSED:
						switch(keyCode)
						{
							case Canvas.KEY_UP:
								TILE_Y -= TILE_HEIGHT;

								if(TILE_Y < 0)
									TILE_Y = 0;

								setRefreshArea(MAP_X, MAP_Y, MAP_WIDTH, MAP_HEIGHT);
								repaintArea();
								break;

							case Canvas.KEY_LEFT:
								TILE_X -= TILE_WIDTH;

								if(TILE_X < 0)
									TILE_X = 0;

								setRefreshArea(MAP_X, MAP_Y, MAP_WIDTH, MAP_HEIGHT);
								repaintArea();
								break;
								
							case Canvas.KEY_RIGHT:
								TILE_X += TILE_WIDTH;

								if(TILE_X > MAP_WIDTH - TILE_WIDTH)
									TILE_X = MAP_WIDTH -TILE_WIDTH;

								setRefreshArea(MAP_X, MAP_Y, MAP_WIDTH, MAP_HEIGHT);
								repaintArea();
								break;
								
							case Canvas.KEY_DOWN:
								TILE_Y += TILE_HEIGHT;

								if(TILE_Y > MAP_HEIGHT - TILE_HEIGHT)
									TILE_Y = MAP_HEIGHT - TILE_HEIGHT;

								setRefreshArea(MAP_X, MAP_Y, MAP_WIDTH, MAP_HEIGHT);
								repaintArea();
								break;

							case Canvas.KEY_FIRE:

								if(eraseMode)
									MAP_INFO[(TILE_Y / TILE_HEIGHT) * MAP_WIDTH / TILE_WIDTH + (TILE_X / TILE_WIDTH)]
										= 0;
								else
								{
									int tHeight = xList.getTile().TILE_HEIGHT;
									int tWidth = xList.getTile().TILE_WIDTH;
									
									for(int i = 0, k = 0; i < tHeight / TILE_HEIGHT; i++)
									{
										for(int j = 0; j < tWidth / TILE_WIDTH; j++)
										{
											MAP_INFO[(TILE_Y / TILE_HEIGHT) * MAP_WIDTH / TILE_WIDTH + (TILE_X / TILE_WIDTH) + (i * MAP_WIDTH / TILE_WIDTH)]
												= xList.getTile().infoTile[k++];
										}
									}
									
//								TILE_X = MAP_WIDTH / TILE_WIDTH / 2 * TILE_WIDTH;
//								TILE_Y = MAP_HEIGHT /TILE_HEIGHT / 2 * TILE_HEIGHT;
								}


								setRefreshArea(LCD_X, LCD_Y, LCD_WIDTH, LCD_HEIGHT);
								repaintArea();
								break;

							case Canvas.KEY_COML:
								curStatus = STATUS_LIST;

								setRefreshArea(LCD_X, LCD_Y, LCD_WIDTH, LCD_HEIGHT);
								repaintArea();
								break;
						}
						break;
						
					case EVT_KEY_RELEASED:
						break;
				}
				break;

// --------------------------------------------------------------------------------
//		
// --------------------------------------------------------------------------------
				
		}
	}
}
