import java.io.*;
import java.util.*;
import javax.microedition.lcdui.*;

import com.xce.lcdui.*;
import com.xce.io.*;
import com.skt.m.*;

public class TorusAI
{

	/*
	** --------------------------------------------------------------------------------
	**	define 	    
	** --------------------------------------------------------------------------------
	*/

	public final static int TORUS_AI_DEGREE = 3; // ؿ 3  AI

	/*
	** --------------------------------------------------------------------------------
	**	Class 	    
	** --------------------------------------------------------------------------------
	*/

	TorusCanvas tCanvas;
	TorusEngine tEngine;

	/*
	** --------------------------------------------------------------------------------
	**	 	    
	** --------------------------------------------------------------------------------
	*/

	int torusValue;		//   ġϴ 
	int torusAIing;		// AI ִϸ̼ 
	int torusGarbage;	//   ִ ġ.

	boolean bMoving;		//  AI ̰ ִ

	/*
	** --------------------------------------------------------------------------------
	**  Function:    
	** 	    startApp
	**
	**  Description: 
	** 	    ø̼ ۵Ǹ 
	**
	**  Input:	
	** 
	**  Return value:
	**	    
	** --------------------------------------------------------------------------------
	*/

	TorusAI(TorusCanvas tCanvas)
	{
		this.tCanvas = tCanvas;
		this.tEngine = tCanvas.tEngine;
	}

	/*
	** --------------------------------------------------------------------------------
	**  Function:    
	** 	    getColor
	**
	**  Description: 
	** 	    Կ    Torus Į ãƳ.
	**
	**  Input:	
	** 
	**  Return value:
	**	    -   Į.
	** --------------------------------------------------------------------------------
	*/

	public int getColor(int [][] TORUS_SLOT)
	{
		int colorSame = 0;

		// Torus .
		for(int colorValue = 1, i = 0, j = 0; colorValue <= TorusCanvas.MAX_COLOR; colorValue++)
		{
			// 3.
			for(i = 0, colorSame = 0; i < TORUS_AI_DEGREE; i++)
			{
				// 3 Slot
				for(j = 0; j < 3; j++)
				{
					//   3 ִ ˻.
					if(colorValue == TORUS_SLOT[i][j])
					{
						if(++colorSame >= 3)
							return colorValue;
					}
				}
			}
		}

		return -1;
	}

	/*
	** --------------------------------------------------------------------------------
	**  Function:    
	** 	    getValue
	**
	**  Description: 
	**	// getColor   Į   MATRIX .
	**	//	0 	 0 	0	4
	**	//	0 	 0 	0	2
	**	//	0 	 0 	0	1
	**	//	100	10	1
	**
	**  Input:	
	** 
	**  Return value:
	**	    
	** --------------------------------------------------------------------------------
	*/

	public void getValue(int colorValue, int [][] TORUS_SLOT)
	{
		if(torusValue < 0)
			return;

		torusValue = 0;

		int i, j, k;

		//  츦 ڷ ٲ۴.
		for(i = 0, j = 0, k = 0; i < TORUS_AI_DEGREE; i++)
		{
			for(j = 0; j < TORUS_AI_DEGREE; j++)
			{
				if(colorValue == TORUS_SLOT[i][j])
				{
					torusValue += pow(2, j) * pow(10, TORUS_AI_DEGREE - i - 1);

					if(++k >= TORUS_AI_DEGREE)
						return;
				}
			}
		}
		
		return;
	}


	/*
	** --------------------------------------------------------------------------------
	**  Function:    
	** 	    engineAI
	**
	**  Description: 
	**		AI ϴ ޼ҵ.
	**
	**  Input:	
	**		TORUS_SLOT 
	** 
	**  Return value:
	**	    
	** --------------------------------------------------------------------------------
	*/

	public void engineAI(int [][] TORUS_SLOT)
	{
		if(TORUS_SLOT == null)
			return;

		// AI  ̰ ִ
		if(!bMoving)
		{
			//    
			int colorValue = getColor(TORUS_SLOT);

			// ġϴ   쿡.
			if(colorValue < 0)
			{
				//   ׿ִ  ã´.
				int maxCount = 0;

				for(int i = 0; i < tEngine.slotCount; i++)
				{
					if(tEngine.slotCurLine[i] > maxCount)
					{
						maxCount = tEngine.slotCurLine[i];
						torusGarbage = i;
					}
				}

				//  Ѱ  ̸ torusValue -1 Ͽ
				//  Ͽ йѴ.
				if(maxCount > 3)
				{
					torusAIing = 0;
					torusValue = -1;

					//      ű.
					moveScrew(torusGarbage);
				}

				return;
			}

			// ġϴ colorValue  torusValue .
			getValue(colorValue, TORUS_SLOT);

			torusAIing = 0;
		}

		switch(torusValue)
		{
			// Ѱ  ׿ йϱ.
			case -1:
				switch(torusAIing)
				{
					case 0:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 1:
						switch(torusGarbage)
						{
							case 0:
								tEngine.keyPressed(Canvas.KEY_RIGHT);

								tEngine.keyPressed(Canvas.KEY_UP);
								break;

							case 1:
								tEngine.keyPressed(Canvas.KEY_RIGHT);

								tEngine.keyPressed(Canvas.KEY_UP);
								break;

							case 2:
								tEngine.keyPressed(Canvas.KEY_LEFT);

								tEngine.keyPressed(Canvas.KEY_UP);
								break;
						}

						break;

					case 2:
						switch(torusGarbage)
						{
							case 0:
								tEngine.keyPressed(Canvas.KEY_RIGHT);

								tEngine.keyPressed(Canvas.KEY_UP);

								torusGarbage = -1;
								torusValue = 0;
								bMoving = false;
								break;

							case 1:
								tEngine.keyPressed(Canvas.KEY_LEFT);

								tEngine.keyPressed(Canvas.KEY_LEFT);
								break;

							case 2:
								tEngine.keyPressed(Canvas.KEY_LEFT);

								tEngine.keyPressed(Canvas.KEY_UP);

								torusGarbage = -1;
								torusValue = 0;
								bMoving = false;
								break;
						}

						break;

					case 3:
						switch(torusGarbage)
						{
							case 0:
								break;

							case 1:
								tEngine.keyPressed(Canvas.KEY_UP);

								torusGarbage = -1;
								torusValue = 0;
								bMoving = false;
								break;

							case 2:
								break;
						}

						break;
				}

				break;

			// 7
			// 0 0 1
			// 0 0 1
			// 0 0 1
			case 7:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 13
			// 0 0 0
			// 0 0 1
			// 0 1 1				
			case 13:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 15
			// 0 0 1
			// 0 0 0
			// 0 1 1
			case 15:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 16
			// 0 0 1
			// 0 0 1
			// 0 1 0
			case 16:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 23
			// 0 0 0
			// 0 1 1
			// 0 0 1
			case 23:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 25
			// 0 0 1
			// 0 1 0
			// 0 0 1
			case 25:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

					case 5:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 26
			// 0 0 1
			// 0 1 1
			// 0 0 0
			case 26:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 31
			// 0 0 0
			// 0 1 0
			// 0 1 1
			case 31:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 32
			// 0 0 0
			// 0 1 1
			// 0 1 0
			case 32:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 34
			// 0 0 1
			// 0 1 0
			// 0 1 0
			case 34:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 43
			// 0 1 0
			// 0 0 1
			// 0 0 1
			case 43:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 45
			// 0 1 1
			// 0 0 0
			// 0 0 1
			case 45:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 46
			// 0 1 1
			// 0 0 1
			// 0 0 0
			case 46:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 51
			// 0 1 0
			// 0 0 0
			// 0 1 1
			case 51:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 52
			// 0 1 0
			// 0 0 1
			// 0 1 0
			case 52:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 54
			// 0 1 1
			// 0 0 0
			// 0 1 0
			case 54:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 61
			// 0 1 0
			// 0 1 0
			// 0 0 1
			case 61:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 62
			// 0 1 0
			// 0 1 1
			// 0 0 0
			case 62:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 64
			// 0 1 1
			// 0 1 0
			// 0 0 0
			case 64:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 70
			// 0 1 0
			// 0 1 0
			// 0 1 0
			case 70:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 103
			// 0 0 0
			// 0 0 1
			// 1 0 1
			case 103:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 105
			// 0 0 1
			// 0 0 0
			// 1 0 1
			case 105:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 106
			// 0 0 1
			// 0 0 1
			// 1 0 0
			case 106:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 112
			// 0 0 0
			// 0 0 1
			// 1 1 0
			case 112:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 114
			// 0 0 1
			// 0 0 0
			// 1 1 0
			case 114:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 121
			// 0 0 0
			// 0 1 0
			// 1 0 1
			case 121:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 122
			// 0 0 0
			// 0 1 1
			// 1 0 0
			case 122:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 124
			// 0 0 1
			// 0 1 0
			// 1 0 0
			case 124:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 130
			// 0 0 0
			// 0 1 0
			// 1 1 0
			case 130:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 141
			// 0 1 0
			// 0 0 0
			// 1 0 1
			case 141:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 142
			// 0 1 0
			// 0 0 1
			// 1 0 0
			case 142:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 144
			// 0 1 1
			// 0 0 0
			// 1 0 0
			case 144:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 150
			// 0 1 0
			// 0 0 0
			// 1 1 0
			case 150:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 160
			// 0 1 0
			// 0 1 0
			// 1 0 0
			case 160:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 203
			// 0 0 0
			// 1 0 1
			// 0 0 1
			case 203:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 205
			// 0 0 1
			// 1 0 0
			// 0 0 1
			case 205:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 206
			// 0 0 1
			// 1 0 1
			// 0 0 0
			case 206:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 211
			// 0 0 0
			// 1 0 0
			// 0 1 1
			case 211:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 212
			// 0 0 0
			// 1 0 1
			// 0 1 0
			case 212:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 214
			// 0 0 1
			// 1 0 0
			// 0 1 0
			case 214:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 221
			// 0 0 0
			// 1 1 0
			// 0 0 1
			case 221:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 224
			// 0 0 1
			// 1 1 0
			// 0 0 0
			case 224:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 230
			// 0 0 0
			// 1 1 0
			// 0 1 0
			case 230:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 241
			// 0 1 0
			// 1 0 0
			// 0 0 1
			case 241:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 242
			// 0 1 0
			// 1 0 1
			// 0 0 0
			case 242:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 244
			// 0 1 1
			// 1 0 0
			// 0 0 0
			case 244:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 250
			// 0 1 0
			// 1 0 0
			// 0 1 0
			case 250:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 260
			// 0 1 0
			// 1 1 0
			// 0 0 0
			case 260:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 301
			// 0 0 0
			// 1 0 0
			// 1 0 1
			case 301:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 302
			// 0 0 0
			// 1 0 1
			// 1 0 0
			case 302:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 304
			// 0 0 1
			// 1 0 0
			// 1 0 0
			case 304:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 310
			// 0 0 0
			// 1 0 0
			// 1 1 0
			case 310:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 320
			// 0 0 0
			// 1 1 0
			// 1 0 0
			case 320:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 340
			// 0 1 0
			// 1 0 0
			// 1 0 0
			case 340:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 403
			// 1 0 0
			// 0 0 1
			// 0 0 1
			case 403:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 405
			// 1 0 1
			// 0 0 0
			// 0 0 1
			case 405:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 406
			// 1 0 1
			// 0 0 1
			// 0 0 0
			case 406:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 411
			// 1 0 0
			// 0 0 0
			// 0 1 1
			case 411:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 412
			// 1 0 0
			// 0 0 1
			// 0 1 0
			case 412:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 414
			// 1 0 1
			// 0 0 0
			// 0 1 0
			case 414:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 421
			// 1 0 0
			// 0 1 0
			// 0 0 1
			case 421:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 422
			// 1 0 0
			// 0 1 1
			// 0 0 0
			case 422:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 424
			// 1 0 1
			// 0 1 0
			// 0 0 0
			case 424:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 430
			// 1 0 0
			// 0 1 0
			// 0 1 0
			case 430:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 441
			// 1 1 0
			// 0 0 0
			// 0 0 1
			case 441:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 442
			// 1 1 0
			// 0 0 1
			// 0 0 0
			case 442:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 450
			// 1 1 0
			// 0 0 0
			// 0 1 0
			case 450:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 460
			// 1 1 0
			// 0 1 0
			// 0 0 0
			case 460:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 501
			// 1 0 0
			// 0 0 0
			// 1 0 1
			case 501:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 502
			// 1 0 0
			// 0 0 1
			// 1 0 0
			case 502:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 504
			// 1 0 1
			// 0 0 0
			// 1 0 0
			case 504:
				switch(torusAIing)
				{
					case 0:
						moveScrew(2);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 510
			// 1 0 0
			// 0 0 0
			// 1 1 0
			case 510:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 520
			// 1 0 0
			// 0 1 0
			// 1 0 0
			case 520:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 540
			// 1 1 0
			// 0 0 0
			// 1 0 0
			case 540:
				switch(torusAIing)
				{
					case 0:
						moveScrew(1);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 601
			// 1 0 0
			// 1 0 0
			// 0 0 1
			case 601:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 602
			// 1 0 0
			// 1 0 1
			// 0 0 0
			case 602:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 604
			// 1 0 1
			// 1 0 0
			// 0 0 0
			case 604:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 610
			// 1 0 0
			// 1 0 0
			// 0 1 0
			case 610:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 620
			// 1 0 0
			// 1 1 0
			// 0 0 0
			case 620:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_LEFT);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 640
			// 1 1 0
			// 1 0 0
			// 0 0 0
			case 640:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_RIGHT);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_UP);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 4:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 5:
						tEngine.keyPressed(Canvas.KEY_LEFT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;

			// 700
			// 1 0 0
			// 1 0 0
			// 1 0 0
			case 700:
				switch(torusAIing)
				{
					case 0:
						moveScrew(0);

						break;

					case 1:
						tEngine.keyPressed(Canvas.KEY_DOWN);

						tEngine.keyPressed(Canvas.KEY_DOWN);
						break;

					case 2:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);
						break;

					case 3:
						tEngine.keyPressed(Canvas.KEY_RIGHT);

						tEngine.keyPressed(Canvas.KEY_UP);

						bMoving = false;
						break;
				}

				break;
		}

		torusAIing++;
	}

	public int pow(int a, int b)
	{
		int c = a;

		for(int i = 1; i < b; i++)
			a *= c;

		a = (b == 0) ? 1 : a;

		return a;
	}

	public void moveScrew(int pos)
	{
		bMoving = true;

		int value = pos - tEngine.screwPos;

		switch(value)
		{
			case -2:
				tEngine.keyPressed(Canvas.KEY_LEFT);

				tEngine.keyPressed(Canvas.KEY_LEFT);
				break;

			case -1:
				tEngine.keyPressed(Canvas.KEY_LEFT);

				break;

			case 0:
				break;

			case 1:
				tEngine.keyPressed(Canvas.KEY_RIGHT);

				break;

			case 2:
				tEngine.keyPressed(Canvas.KEY_RIGHT);

				tEngine.keyPressed(Canvas.KEY_RIGHT);
				break;
		}
	}
}
