import java.io.*;
import java.util.*;
import javax.microedition.lcdui.*;

import com.xce.lcdui.*;
import com.xce.io.*;
import com.skt.m.*;

public class TorusCanvas extends Canvas implements XTimerListener
{

/*
** -----------------------------------------------------------------
**	define 	    
** -----------------------------------------------------------------
*/

	// ܸ LCD (120-144 ܸ  Ѵ.)
	public static int LCD_WIDTH			= 120;
	public static int LCD_HEIGHT		= 144;
	public static int LCD_X				= (XDisplay.width - LCD_WIDTH) / 2;
	public static int LCD_Y				= (XDisplay.height2 - LCD_HEIGHT) / 2;



	// 
	public final static int TORUS_INTRO	= 0;		// Ʈ
	public final static int TORUS_READY	= 1;		// 
	public final static int TORUS_GO		= 2;		//  .
	public final static int TORUS_OVER	= 3;		//  


	// Bar : ,   Screw : .
	public final static int[][] TORUS_STAGE = {{3, 7, 3}, 
		{4, 8, 4}, {5, 9, 5}, {6, 10, 6}, {7, 11, 7}, 
		{8, 12, 8}, {9, 13, 9}, {10, 14, 10}, {11, 15, 11}, {12, 16, 12}};


	public final static int MAX_COLOR 			= 4;	// Torus ִ  .
	public final static int LEVEL_UP_CONDITION = 300;	// .

	// Torus  	
	public final static int MOTION_Y = LCD_Y + 12;
	public final static int MAX_STRING = 20;			// ִ ̸ Է.


/*
** -----------------------------------------------------------------
**	Class 	    
** -----------------------------------------------------------------
*/

	private int REAREA_X;				// ÷  X
	private int REAREA_Y;				// ÷  Y
	private int REAREA_WIDTH;		// ÷  WIDTH
	private int REAREA_HEIGHT;		// ÷  HEIGHT

	TorusMIDlet 	tMIDlet;		// MIDlet	
	TorusEngine 	tEngine;		// Engine
	TorusAI		tAI;			// AI
	XTimer		xTimer;		// Timer


/*
** -----------------------------------------------------------------
**	 	    
** -----------------------------------------------------------------
*/

	//  .
	int statusTorus = TORUS_INTRO;
	int levelUp;				//  
	int aniIntro;				// Intor Ani

	static int GAME_LEVEL = 9;	// ʱ : 8, ߱ 10,  10;

	String nameNscore;		// 
	XTextField xTextField;		// ̸ 

	Graphics2D g2 = Graphics2D.getGraphics2D(Toolkit.graphics);
	
/*
** -----------------------------------------------------------------
**	Image 	    
** -----------------------------------------------------------------
*/

	
	Image imgIntro;		// Ʈ
	Image imgSlot;		// SLOT
	Image imgTorus;		// .
	Image imgScrewBar;	// Screw Bar
	Image imgScrewPin;	// Screw Pin
	Image[] imgBG = new Image[3];	// 


	Image imgGameOver;		// Game Over
	Image imgLevel;			//  
	Image imgSNum;			//  
	Image imgLNum;			// ū 
	Image imgAllClear;		// All Clear


/*
** -----------------------------------------------------------------
**	Method 	    
** -----------------------------------------------------------------
*/


/*
** -----------------------------------------------------------------
**  Function:    
** 	    	- TorusCanvas
**
**  Description: 
** 	    	- .
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/

	TorusCanvas(TorusMIDlet tMIDlet) 
	{
		this.tMIDlet = tMIDlet;
		tEngine = new TorusEngine(this);
		tAI = new TorusAI(this);		// AI

		try
		{
			// ̹ ȭ    ϰ ϱ ؼ
			// Ϻη PNG оϴ.
			// LBM ؼ Mixer ̿ص ǰ..
			//  ε ص ǰ    ׽Ʈ  
			//  ̹   ʾƼ..׷  ʽϴ.
			imgIntro 		= Image.createImage("/img/Intro.png");		// Ʈ
			imgSlot 		= Image.createImage("/img/Slot.png");		// 
			imgTorus 	= Image.createImage("/img/Torus.png");		// 
			imgScrewBar 	= Image.createImage("/img/ScrewBar.png");		// .
			imgScrewPin 	= Image.createImage("/img/ScrewPin.png");		// .
			imgBG[0] 	= Image.createImage("/img/BG1.png");		// Back Ground			
			imgBG[1] 	= Image.createImage("/img/BG2.png");		// Back Ground			
			imgBG[2] 	= Image.createImage("/img/BG3.png");		// Back Ground			


			imgGameOver = Image.createImage("/img/Go.png");	// Game Over
			imgLevel = Image.createImage("/img/Level.png");		// Level
			imgSNum = Image.createImage("/img/SNum.png");		// Num
			imgLNum = Image.createImage("/img/LNum.png");		// Num
			imgAllClear = Image.createImage("/img/AllClear.png");	// All Clear
			
		}catch(Exception e){}


		// ̸ Է.
		xTextField = new XTextField("", MAX_STRING, TextField.ANY, this);
		xTextField.setBounds((XDisplay.width - 8 * Toolkit.MAX_CHARWIDTH) / 2, LCD_Y + LCD_HEIGHT - 30,
			8 * Toolkit.MAX_CHARWIDTH, Toolkit.FONT_HEIGHT + 1);

		xTimer = new XTimer(300);
 		xTimer.setTimerListener(this);

		setRefreshArea(0, 0, XDisplay.width, XDisplay.height2);
		xTimer.start();
 	}



/*
** -----------------------------------------------------------------
**  Function:    
** 	    	- gameStart
**
**  Description: 
** 	    	-  .(ʱȭ)
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/

	public void gameStart(int level)
	{
		GAME_LEVEL = level;	
		levelUp = 0;
		tEngine.curLevel = 0;
		tEngine.scoreTorus = 0;

		// ù° 
		tEngine.statgeInit(0);
	}


/*
** -----------------------------------------------------------------
**  Function:    
** 	    	- gameOver
**
**  Description: 
** 	    	-  Over(̸ )
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/
	public void gameOver()
	{
		xTimer.cancel();
		statusTorus = TORUS_OVER;

		xTextField.setText("");
		xTextField.setFocus(true);
		xTimer.setTime(300);

		setRefreshArea(0, 0, XDisplay.width, XDisplay.height2);
		repaintArea();
	}

	
/*
** -----------------------------------------------------------------
**  Function:
** 	    setRefreshArea
**
**  Description:
** 	    repaint  Ѵ.
**
**  Input:
**		x :
**		y :
**		width :
**		height :
**
**  Return value:
**
** -----------------------------------------------------------------
*/
	public void setRefreshArea(int x, int y, int width, int height)
	{
		REAREA_X = x;
		REAREA_Y = y;
		REAREA_WIDTH = width;
		REAREA_HEIGHT = height;
	}


	public void repaintArea()
	{
		repaint(REAREA_X, REAREA_Y, REAREA_WIDTH, REAREA_HEIGHT);


//		serviceRepaints();
	}


/*
** -----------------------------------------------------------------
**  Function:    
** 	    performed
**
**  Description: 
** 	    
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/	

	public void performed(XTimer aXTimer)
	{
		// AI 3 Slotۿ  ϱ  
		//  Ǹ ȵȴ.
		switch(levelUp)		
//		switch(levelUp++)
		{
			// Screw Ѵܰ ª 
			case LEVEL_UP_CONDITION:
				// Back Color
				Toolkit.graphics.setColor(0x000000);
				Toolkit.graphics.fillRect(tEngine.SLOT_X, tEngine.SCREWPIN_Y, 
					tEngine.SLOT_WIDTH, 
					tEngine.SCREWPIN_HEIGHT + TorusEngine.SCREWBAR_HEIGHT);

				// Screw  ش.
				tEngine.screwLevelUp();

				// Screw ׷ش.
				tEngine.drawScrewTorus(Toolkit.graphics);
				break;

			//  ϳ  þ .
			case LEVEL_UP_CONDITION * 2:
				//  ϳ 涧
				//  ʱȭ Ų.
				levelUp = 0;

				//  ϳ ߰Ų.
				tEngine.slotLevelUp();

				//  غ.
				statusTorus = TORUS_READY;
				
				setRefreshArea(0, 0, XDisplay.width, XDisplay.height2);
				break;
		}

//		AI κ ̺κ  Ű ˴ϴ.
		if(statusTorus == TORUS_GO)
			tAI.engineAI(tEngine.TORUS_SLOT);

		repaint(REAREA_X, REAREA_Y, REAREA_WIDTH, REAREA_HEIGHT);
		serviceRepaints();
	}
	

/*
** -----------------------------------------------------------------
**  Function:    
** 	    paint
**
**  Description: 
**
**  Input:	
** 
**  Return value:
**	    
** -----------------------------------------------------------------
*/	
	public void paint(Graphics g)
	{
		switch(statusTorus)
		{
			// Ʈ ȭ ֱ.
			case TORUS_INTRO:
				g.drawImage(imgBG[aniIntro % 3], XDisplay.width / 2, XDisplay.height2 / 2, g.HCENTER | g.VCENTER);

				g2.drawImage((XDisplay.width - 110) / 2, LCD_Y + 10,
					imgIntro, 0, (aniIntro++ % 4) * 23, 110, 23, Graphics2D.DRAW_COPY);

				//  ֱ.
				if(nameNscore != null)
				{
					g.setColor(0x000000);
					g.fillRect((XDisplay.width - Toolkit.DEFAULT_FONT.stringWidth(nameNscore)) / 2 - 2,
						LCD_Y + 48, Toolkit.DEFAULT_FONT.stringWidth(nameNscore) + 4, 19);
					g.setColor(0xffffff);
					g.drawString(nameNscore, 
						(XDisplay.width - Toolkit.DEFAULT_FONT.stringWidth(nameNscore)) / 2, LCD_Y + 50, g.LEFT | g.TOP);
				}
					
				g.drawImage(imgLevel, XDisplay.width / 2, LCD_Y + 90, g.HCENTER | g.TOP);
				break;

			case TORUS_READY:
				//  ׸
				g.drawImage(imgBG[aniIntro++ % 3], LCD_X + LCD_WIDTH / 2, LCD_Y + LCD_HEIGHT / 2, g.HCENTER | g.VCENTER);

				// Torus   ˰ ׸.
				g.setColor(0x000000);
				g.fillRect(tEngine.SLOT_X, MOTION_Y,
					tEngine.SLOT_WIDTH, tEngine.SLOT_Y - MOTION_Y);

				// Slot ׸.
				tEngine.drawSlotTorus(g);

				// Screw ׸.
				tEngine.drawScrewTorus(g);

				//  Ѵ.
				statusTorus = TORUS_GO;

				// Repaint Ѵ.
				// Torus   Repaintϸ ȴ.
				setRefreshArea(tEngine.SLOT_X, 0, 
					tEngine.SLOT_WIDTH, LCD_Y + LCD_HEIGHT);
				break;

			// .
			case TORUS_GO:
				tEngine.paint(g);
				break;

			//  .
			case TORUS_OVER:
				g.drawImage(imgGameOver, XDisplay.width / 2, XDisplay.height2 / 2, g.HCENTER | g.VCENTER);
				tEngine.drawScore(g, true);

				xTextField.paint(g);
				break;
		}
	}


/*
** -----------------------------------------------------------------
**  Function:
** 	    keyPressed
**
**  Description:
** 	    -  Ű  ó
**
**  Input:
**		// SK-VM Specific
**		KEY_CLR		= 8;
**
**	    	KEY_POUND 	= 35;
**	 	KEY_NUM0 	= 48;
**	    	KEY_NUM1 	= 49;
**	    	KEY_NUM2 	= 50;
**	    	KEY_NUM3 	= 51;
**	    	KEY_NUM4 	= 52;
**	    	KEY_NUM5 	= 53;
**	    	KEY_NUM6 	= 54;
**	    	KEY_NUM7 	= 55;
**	    	KEY_NUM8 	= 56;
**	    	KEY_NUM9 	= 57;
**	    	KEY_STAR 	= 42;
**
**		KEY_COML	= 129;
**		KEY_COMC	= 130;	// RESERVED
**		KEY_COMR	= 131;
**
**		KEY_UP		= 141;
**		KEY_LEFT		= 142;
**		KEY_RIGHT	= 145;
**		KEY_DOWN	= 146;
**		KEY_FIRE		= 148;
**
**		KEY_CALL	= 190;
**		KEY_END		= 191;
**
**		KEY_FLIP_OPEN	= 192;
**		KEY_FLIP_CLOSE	= 193;
**		KEY_VOL_UP		= 194;
**		KEY_VOL_DOWN	= 195;
**
**  Return value:
**
** -----------------------------------------------------------------
*/


	public void keyPressed(int keyCode)
	{
		switch(statusTorus)
		{
			//   Ѵ.
			// ش   Ÿ  Ͻô  Ͻø ˴ϴ.
			case TORUS_INTRO:
				switch(keyCode)
				{
					// ʺ 
					case Canvas.KEY_NUM1:
						gameStart(9);
			
						xTimer.setTime(300);
						statusTorus = TORUS_READY;
						repaintArea();
						break;

					// ߰ 
					case Canvas.KEY_NUM2:
						gameStart(9);

						xTimer.setTime(200);
						statusTorus = TORUS_READY;
						repaintArea();
						break;

					//  
					case Canvas.KEY_NUM3:
						gameStart(12);

						xTimer.setTime(100);
						statusTorus = TORUS_READY;
						repaintArea();
						break;
				}
				break;

			case TORUS_GO:
				tEngine.keyPressed(keyCode);
				break;

			//  
			case TORUS_OVER:
				switch(keyCode)
				{
					case Canvas.KEY_FIRE:
					case Canvas.KEY_COMR:
						xTextField.setFocus(false);

						//  ̸ Ѵ.
						if(nameNscore == null ||
							tEngine.scoreTorus >= Integer.parseInt(nameNscore.substring(nameNscore.indexOf(":") + 1, nameNscore.length())))
						{
							tMIDlet.writeInfo(xTextField.getText(), tEngine.scoreTorus);
							nameNscore = tMIDlet.readInfo();
						}
							
						statusTorus = TORUS_INTRO;

						xTimer.resume();
						setRefreshArea(0, 0, XDisplay.width, XDisplay.height2);
						repaintArea();
						return;
				}

				if(xTextField.hasFocus())
					xTextField.keyPressed(keyCode);
				break;
		}
	}

/*
** -----------------------------------------------------------------
**  Function:
** 	    keyReleased
**
**  Description:
**
**
**  Input:
**
**  Return value:
**
** -----------------------------------------------------------------
*/

	public void keyReleased(int keyCode)
	{
	}
}
